/* Function to decode RC5 commands
 * V0 2013-01-15
 */

#define IntT0reload 0x04			//T0 extension to clock RC5 receiver

__data volatile unsigned char rCommand;   	//Bitte erhalten! Wenn Befehl fertig: auswerten
__data volatile unsigned char rAddress;   	//Bitte erhalten! Wenn Befehl fertig: auswerten
__data volatile unsigned char rCounter;   	//Bitte erhalten!

__bit volatile RTbit;			//Togglebit von RC5

//State Machine zur Decodierung des RC5-Fernbedieungscodes
__code unsigned char tblRemote[] =
{1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 0,
 8, 0, 9, 0, 10, 0, 11, 0, 12, 0, 13, 0, 14,
 0, 15, 0, 16, 0, 17, 0, 18, 0, 19, 0, 20, 0,
 20, 21, 0, 22, 0, 23, 26, 24, 26, 25, 26, 0,
 27, 0, 28, 0, 29, 31, 30, 31, 0, 31, 0, 32,
 0, 33, 35, 34, 35, 43, 36, 43, 37, 0, 38, 40,
 39, 40, 0, 40, 0, 41, 0, 42, 35, 34, 35, 44,
 0, 45, 48, 46, 48, 47, 48, 0, 49, 0, 50, 0, 34, 43};

void T0_isr(void) __interrupt(1) __using(isrregisterbank)	//int from Timer 0 to read RC5 state
{
	__data static unsigned char IntT0Count;		//VerlÃ¤ngerung von T0
	__data static unsigned char rc5state;
	__bit static Rbit;				//Dedektiertes Bit von RC5

	--IntT0Count;
	if (0==IntT0Count)
		{
		IntT0Count=IntT0reload;			//Reload counter
		rc5state=rc5state<<1;
		if (0==_RC5inp)				//insert inverted input
			{
			rc5state|=1;
			}
		rc5state=tblRemote[rc5state];
		if (33==rc5state)				//Startsequenz erkannt?
			{
			rCounter=0;			//alles zurÃ¼cksetzen
			rAddress=0;
			rCommand=0;
			}
		else if ((42==rc5state) || (50==rc5state))	 //Erkanntes Bit einorden
			{
			if (42==rc5state)			//Nutzbit 1 erkannt?
				{
				Rbit=1;
				}
			else if (50==rc5state)		//Nutzbit 0 erkannt?
				{
				Rbit=0;
				}
    			++rCounter;			//Da neues Bit ...
			if (1==rCounter)
  				{
  				RTbit=Rbit;
  				}
			else if (7>rCounter)		//Adressbit
				{
  				rAddress=rAddress<<1;
  				rAddress|=Rbit;
  				}
			else				//Commandbit
				{
  				rCommand=rCommand<<1;
  				rCommand|=Rbit;
  				}
			}
		}
}
